## dpkg 1.22.6ubuntu6.5trisquel5

=== debian/changelog ===
dpkg (1.22.6ubuntu6.5trisquel5) ecne-security; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 24 Sep 2025 16:51:56 +0000

=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10~),
 pkgconf,
# Version needed for ITS support.
 gettext (>= 0.19.7),
# Version needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 libmd-dev,
 zlib1g-dev,
 libbz2-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210),
# Needed for the functional test.
 bzip2 <!nocheck>,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0) <!nocheck>,
# Needed for the functional test.
 zstd <!nocheck>,
# Needed for the author release process.
 git <pkg.dpkg.author-release>,
 ca-certificates <pkg.dpkg.author-release>,
 libmodule-build-perl <pkg.dpkg.author-release>,
# Needed for the test suite in author mode.
 fakeroot <pkg.dpkg.author-testing>,
 gnupg <pkg.dpkg.author-testing>,
 cppcheck <pkg.dpkg.author-testing>,
 shellcheck <pkg.dpkg.author-testing>,
 aspell <pkg.dpkg.author-testing>,
 aspell-en <pkg.dpkg.author-testing>,
 codespell <pkg.dpkg.author-testing>,
 i18nspector <pkg.dpkg.author-testing>,
 libtest-minimumversion-perl <pkg.dpkg.author-testing>,
 libtest-perl-critic-perl <pkg.dpkg.author-testing>,
 libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
 libtest-pod-perl <pkg.dpkg.author-testing>,
 libtest-spelling-perl <pkg.dpkg.author-testing>,
 libtest-strict-perl <pkg.dpkg.author-testing>,
 libtest-synopsis-perl <pkg.dpkg.author-testing>,
# Needed for code coverage reports.
 lcov <pkg.dpkg.code-coverage>,
 libdevel-cover-perl <pkg.dpkg.code-coverage>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Version needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libmd-dev,
 zlib1g-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Version needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
# Version needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
 lto-disabled-list,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
 gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.33.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Provides:
 dpkg-build-api (= 0),
 dpkg-build-api (= 1),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Replaces: trisquel-base-data
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Version needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
Suggests:
 debian-keyring,
 gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
 gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.33.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildInfo: build information functions
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 libdpkg-perl,
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

## dpkg 1.22.6ubuntu14

=== debian/changelog ===
dpkg (1.22.6ubuntu14) oracular; urgency=medium

  * Export environment variables DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH,
    DEB_SOURCE, and DEB_VERSION when including buildflags.mk (LP: #2070015)
  * buildflags: document RUSTFLAGS
  * buildflags: Always set RUSTFLAGS
  * buildflags: set origin of env vars for ELF package metadata

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 21 Jun 2024 18:46:10 +0200

dpkg (1.22.6ubuntu13) oracular; urgency=medium

  * dpkg-buildflags: stop setting osVersion in ELF metadata (LP: #2069599)
  * Fix missing DPKG_BUILDPACKAGE_* env variables by exposing them via
    dpkg-buildflags instead of dpkg-buildpackage. (LP: #2069722) Rename the
    environment variables in that step:
    - DPKG_BUILDPACKAGE_PACKAGE_ARCH -> DEB_HOST_ARCH
    - DPKG_BUILDPACKAGE_PACKAGE_NAME -> DEB_SOURCE
    - DPKG_BUILDPACKAGE_PACKAGE_VERSION -> DEB_VERSION
    - DPKG_BUILDPACKAGE_OS_RELEASE_ID -> DEB_BUILD_OS_RELEASE_ID
    - DPKG_BUILDPACKAGE_DEBUGINFOD_URLS -> DEB_BUILD_DEBUG_INFO_URL

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 20 Jun 2024 11:00:11 +0200

dpkg (1.22.6ubuntu12) oracular; urgency=medium

  [ Zixing Liu ]
  * dpkg-buildflags: set RUSTFLAGS to influence the command line flags cargo
    will pass to rustc, and set the flags to include framepointers when the
    framepointer feature of the qa area is enabled.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 19 Jun 2024 11:08:14 +1200

dpkg (1.22.6ubuntu11) oracular; urgency=medium

  [ Luca Boccassi ]
  * tests: avoid failing under DEB_VENDOR != Debian
  * dpkg-buildflags: enable ELF package note metadata

 -- Benjamin Drung <bdrung@ubuntu.com>  Sat, 15 Jun 2024 00:20:30 +0200

dpkg (1.22.6ubuntu10) oracular; urgency=medium

  * Also disable framepointer on s390x, leaving only -mbackchain.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 01 May 2024 11:45:38 -0700

dpkg (1.22.6ubuntu9) oracular; urgency=medium

  * Disable framepointer on ppc64el.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 01 May 2024 10:20:49 -0700

dpkg (1.22.6ubuntu8) oracular; urgency=medium

  [ Krzysztof Adamski ]
  * Add a note about different behaviour of dpkg-buildflags with respect to
    LTO on Ubuntu.  (LP: #2059107)

 -- Dan Bungert <daniel.bungert@canonical.com>  Tue, 30 Apr 2024 13:02:11 -0600

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	# EOL

# elfpackagemetadata needs dpkg-buildpackage to set some env vars, so disable
# it until a new enough version of dpkg-dev is available.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=-elfpackagemetadata
export DEB_CFLAGS_MAINT_APPEND = $(WFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(WFLAGS)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/build-aux/run-script scripts/dpkg-buildflags.pl

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	TESTSUITEFLAGS += --verbose
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  TESTSUITEFLAGS += -j$(NUMJOBS)
endif

testflags = TESTSUITEFLAGS=$(TESTSUITEFLAGS) TEST_PARALLEL=$(NUMJOBS)

dpkg_vendor = \
	$(CURDIR)/build-aux/run-script scripts/dpkg-vendor.pl

DEB_VENDOR = $(shell $(call dpkg_vendor) --query Vendor)

D := $(CURDIR)/debian/tmp

%:
	dh $@ --builddirectory=build-tree

override_dh_auto_configure:
	dh_auto_configure -- \
		$(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-libz \
		--with-liblzma \
		--with-libzstd \
		--with-libbz2 \
		# EOL

execute_after_dh_auto_install:
	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

override_dh_auto_test:
	dh_auto_test -- $(testflags)

override_dh_installsystemd:
	dh_installsystemd -a --name=dpkg-db-backup \
	  --no-start --no-stop-on-upgrade

execute_after_dh_installlogrotate:
	dh_installlogrotate --name=alternatives

override_dh_installdocs:
	dh_installdocs -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_bugfiles:
	dh_bugfiles -A

override_dh_compress:
	dh_compress -Xspec/

ifeq (,$(filter $(DEB_VENDOR),Debian Ubuntu))
execute_after_dh_install:
	dh_install -pdpkg usr/sbin/dpkg-fsys-usrunmess

# XXX: We cannot use -X, see debhelper #756366.
execute_after_dh_installman:
	dh_installman -pdpkg $(wildcard \
	  $(D)/usr/share/man/*/dpkg-fsys-usrunmess.8  \
	  $(D)/usr/share/man/*/*/dpkg-fsys-usrunmess.8 \
	)

# XXX: We cannot pass pathnames to dh_installman w/o $(D), and then dh_missing
# complains that the pathnames do not match, so ignore them.
override_dh_missing:
	dh_missing -Xdpkg-fsys-usrunmess.8
else
override_dh_missing:
	dh_missing -Xdpkg-fsys-usrunmess
endif

override_dh_builddeb:
	# Make debootstrap life easier on non-Debian based systems by
	# compressing dpkg.deb with xz instead of zstd.
	dh_builddeb -pdpkg -- -Zxz
	dh_builddeb -Ndpkg

## dpkg 1.22.11

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,7 @@
 	-Wno-unused-parameter \
 	# EOL
 
-# elfpackagemetadata needs dpkg-buildpackage to set some env vars, so disable
-# it until a new enough version of dpkg-dev is available.
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=-elfpackagemetadata
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND = $(WFLAGS)
 export DEB_CXXFLAGS_MAINT_APPEND = $(WFLAGS)
 
@@ -28,17 +26,15 @@
 	confflags += --with-libselinux
 endif
 ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
-	TESTSUITEFLAGS += --verbose
+  testflags += TEST_VERBOSE=1
 endif
 
 # Enable parallel test suite
 NUMJOBS = 1
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
   NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-  TESTSUITEFLAGS += -j$(NUMJOBS)
+  testflags += TEST_PARALLEL=$(NUMJOBS)
 endif
-
-testflags = TESTSUITEFLAGS=$(TESTSUITEFLAGS) TEST_PARALLEL=$(NUMJOBS)
 
 dpkg_vendor = \
 	$(CURDIR)/build-aux/run-script scripts/dpkg-vendor.pl
@@ -110,9 +106,3 @@
 override_dh_missing:
 	dh_missing -Xdpkg-fsys-usrunmess
 endif
-
-override_dh_builddeb:
-	# Make debootstrap life easier on non-Debian based systems by
-	# compressing dpkg.deb with xz instead of zstd.
-	dh_builddeb -pdpkg -- -Zxz
-	dh_builddeb -Ndpkg

## dpkg 1.22.11ubuntu1

=== tests/t-provides/Makefile ===
TESTS_DEB := \
	pkg-provides pkg-provides-10 pkg-provides-20 pkg-provides-10-20 \
	pkg-depends pkg-depends-eq pkg-depends-le pkg-depends-ge \
	pkg-predepends pkg-predepends-eq pkg-predepends-le pkg-predepends-ge \
	pkg-breaks pkg-breaks-eq pkg-breaks-le pkg-breaks-ge \
	pkg-conflicts pkg-conflicts-eq pkg-conflicts-le pkg-conflicts-ge \
	pkg-a-depends-ge-lt pkg-b-provides-10 pkg-c-provides-20

include ../Test.mk

test-bogus:
	# test building with bogus provides
	! $(DPKG_BUILD_DEB) pkg-provides-bogus

	# build bogus packages
	$(DPKG_BUILD_DEB) --nocheck pkg-provides-bogus

	# test installing packages with bogus provides
	! $(DPKG_INSTALL) pkg-provides-bogus.deb
	$(call pkg_is_not_installed,pkg-provides-bogus)

define PURGE_DEPENDS
$(DPKG_PURGE) pkg-depends
$(DPKG_PURGE) pkg-depends-le
$(DPKG_PURGE) pkg-depends-eq
$(DPKG_PURGE) pkg-depends-ge
endef

test-depends:
	# The provided dependency is not present, fail
	! $(DPKG_INSTALL) pkg-depends.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_INSTALL) pkg-depends.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_PURGE) pkg-provides

	$(PURGE_DEPENDS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	$(DPKG_INSTALL) pkg-depends.deb
	$(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_DEPENDS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	$(DPKG_INSTALL) pkg-depends.deb
	$(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	$(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_DEPENDS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	$(DPKG_INSTALL) pkg-depends.deb
	$(DPKG_INSTALL) pkg-depends-eq.deb
	$(DPKG_INSTALL) pkg-depends-le.deb
	$(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_DEPENDS)

	$(DPKG_PURGE) pkg-provides

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-c-provides-20.deb
	! $(DPKG_INSTALL) pkg-a-depends-ge-lt.deb
	$(DPKG_PURGE) pkg-a-depends-ge-lt
	$(DPKG_PURGE) pkg-c-provides

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-b-provides-10.deb
	$(DPKG_INSTALL) pkg-a-depends-ge-lt.deb
	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-c-provides-20.deb

	# Cannot purge the only package satisfying the dependency
	! $(DPKG_PURGE) pkg-b-provides
	# Can purge package not satisfying the dependency
	$(DPKG_PURGE) pkg-c-provides

	$(DPKG_PURGE) pkg-a-depends-ge-lt
	$(DPKG_PURGE) pkg-b-provides

	# The provided dependency is removed, pass
	$(DPKG_PURGE) pkg-provides

define PURGE_PREDEPENDS
$(DPKG_PURGE) pkg-predepends
$(DPKG_PURGE) pkg-predepends-le
$(DPKG_PURGE) pkg-predepends-eq
$(DPKG_PURGE) pkg-predepends-ge
endef

test-predepends:
	# The provided predependency is not present, fail
	! $(DPKG_UNPACK) pkg-predepends.deb
	! $(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-le.deb
	! $(DPKG_UNPACK) pkg-predepends-ge.deb

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	! $(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-le.deb
	! $(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_PURGE) pkg-provides

	$(PURGE_PREDEPENDS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	$(DPKG_UNPACK) pkg-predepends-le.deb
	! $(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_PREDEPENDS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	$(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-le.deb
	$(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_PREDEPENDS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	$(DPKG_UNPACK) pkg-predepends-eq.deb
	$(DPKG_UNPACK) pkg-predepends-le.deb
	$(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_PREDEPENDS)

	# The provided predependency is removed, pass
	$(DPKG_PURGE) pkg-provides

define PURGE_BREAKS
$(DPKG_PURGE) pkg-breaks
$(DPKG_PURGE) pkg-breaks-le
$(DPKG_PURGE) pkg-breaks-eq
$(DPKG_PURGE) pkg-breaks-ge
endef

test-breaks:
	# The provided dependency is not present, pass
	$(DPKG_INSTALL) pkg-breaks.deb
	$(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-le.deb
	$(DPKG_INSTALL) pkg-breaks-ge.deb

	$(PURGE_BREAKS)

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	$(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-le.deb
	$(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_PURGE) pkg-provides

	$(PURGE_BREAKS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	! $(DPKG_INSTALL) pkg-breaks-le.deb
	$(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_BREAKS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	! $(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-le.deb
	! $(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_BREAKS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	! $(DPKG_INSTALL) pkg-breaks-eq.deb
	! $(DPKG_INSTALL) pkg-breaks-le.deb
	! $(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_BREAKS)

	# The provided dependency is removed, pass
	$(DPKG_PURGE) pkg-provides

define PURGE_CONFLICTS
$(DPKG_PURGE) pkg-conflicts
$(DPKG_PURGE) pkg-conflicts-le
$(DPKG_PURGE) pkg-conflicts-eq
$(DPKG_PURGE) pkg-conflicts-ge
endef

test-conflicts:
	# The provided predependency is not present, fail
	$(DPKG_UNPACK) pkg-conflicts.deb
	$(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-le.deb
	$(DPKG_UNPACK) pkg-conflicts-ge.deb

	$(PURGE_CONFLICTS)

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	$(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-le.deb
	$(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_PURGE) pkg-provides

	$(PURGE_CONFLICTS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	! $(DPKG_UNPACK) pkg-conflicts-le.deb
	$(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_CONFLICTS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	! $(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-le.deb
	! $(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_CONFLICTS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	! $(DPKG_UNPACK) pkg-conflicts-eq.deb
	! $(DPKG_UNPACK) pkg-conflicts-le.deb
	! $(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_CONFLICTS)

	# The provided predependency is removed, pass
	$(DPKG_PURGE) pkg-provides

test-case: test-bogus test-depends test-predepends test-breaks test-conflicts

test-clean:
	-$(DPKG_PURGE) pkg-depends
	-$(DPKG_PURGE) pkg-depends-eq
	-$(DPKG_PURGE) pkg-depends-ge
	-$(DPKG_PURGE) pkg-depends-le
	-$(DPKG_PURGE) pkg-predepends
	-$(DPKG_PURGE) pkg-predepends-eq
	-$(DPKG_PURGE) pkg-predepends-ge
	-$(DPKG_PURGE) pkg-predepends-le
	-$(DPKG_PURGE) pkg-breaks
	-$(DPKG_PURGE) pkg-breaks-eq
	-$(DPKG_PURGE) pkg-breaks-ge
	-$(DPKG_PURGE) pkg-breaks-le
	-$(DPKG_PURGE) pkg-conflicts
	-$(DPKG_PURGE) pkg-conflicts-eq
	-$(DPKG_PURGE) pkg-conflicts-ge
	-$(DPKG_PURGE) pkg-conflicts-le
	-$(DPKG_PURGE) pkg-provides
	-$(DPKG_PURGE) pkg-a-depends-ge-lt
	-$(DPKG_PURGE) pkg-b-provides
	-$(DPKG_PURGE) pkg-c-provides

	rm -f pkg-provides-bogus.deb

=== debian/changelog ===
dpkg (1.22.11ubuntu1) oracular; urgency=medium

  * Merge with Debian; remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Fix debian/rules duplicate invocations of dh_builddeb
    - lib/dpkg/compress.c: clean up override of the default zstd compression
      level
    - dpkg-buildflags: Explicitly turn off hardening flags when requested.
    - Export environment variables DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH,
      DEB_SOURCE, and DEB_VERSION when including buildflags.mk (LP: #2070015)
    - buildflags: document RUSTFLAGS
    - buildflags: Always set RUSTFLAGS
    - tests: avoid failing under DEB_VENDOR != Debian
    - dpkg-buildflags: enable ELF package note metadata
    - buildflags: set origin of env vars for ELF package metadata
    - Export ELF_PACKAGE_METADATA for a build. Picked up by GCC and clang.
      Passing -specs explicitly can be dropped in a follow-up upload.
    - dpkg-buildflags: set RUSTFLAGS to influence the command line flags cargo
      will pass to rustc, and set the flags to include framepointers when the
      framepointer feature of the qa area is enabled.
    - Disable framepointer on ppc64el.
    - Disable framepointer on s390x, leaving only -mbackchain.
    - Add a note about different behaviour of dpkg-buildflags with respect to
      LTO on Ubuntu.
  * dpkg-buildpackage: Construct ELF_PACKAGE_METADATA, and set in the
    environment if not already set.  This setting is picked up by
    GCC and clang, passing a --package-metadata option the the linker.
  * Stop passing --specs for metadata information. It's too fragile
    and only works for GCC. Also introduces a lot of packaging delta.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 05 Aug 2024 11:12:02 +0200

dpkg (1.22.11) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Shlibs::Cppfilt: Do not normalize angle brackets for operators.
      Closes: #1076067
  * Documentation:
    - doc: Replace references to crypto-refresh and RFC4880 with RFC9580.
  * Build system:
    - Use 'command -v' instead of 'which'.
    - Remove generated spacesyms.o and spacesyms.c on clean.
    - Add declaration for funcs symbols in spacesyms.c.
  * Test suite:
    - Fix coding style in perl test cases.
    - Improve Dpkg::Changelog data test case message.
    - Refactor setup_changelog() in Dpkg::Changelog test.
    - Unroll Dpkg::Changelog file tests loop.
    - Refactor load_objdump_obj().

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Thu, 01 Aug 2024 12:39:16 +0200

dpkg (1.22.10ubuntu2) oracular; urgency=medium

  * Update scripts/mk/buildflags.mk to use new way of computing
    $(dpkg_datadir), fixing many ftbfs.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 02 Aug 2024 10:10:20 +1200

dpkg (1.22.10ubuntu1) oracular; urgency=medium

  * Merge with Debian; remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade


=== debian/rules ===
--- 
+++ 
@@ -106,3 +106,9 @@
 override_dh_missing:
 	dh_missing -Xdpkg-fsys-usrunmess
 endif
+
+override_dh_builddeb:
+	# Make debootstrap life easier on non-Debian based systems by
+	# compressing dpkg.deb with xz instead of zstd.
+	dh_builddeb -pdpkg -- -Zxz
+	dh_builddeb -Ndpkg

## dpkg 1.22.11ubuntu3

=== debian/changelog ===
dpkg (1.22.11ubuntu3) plucky; urgency=medium

  * Adjust dpkg-buildflags test cases.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 29 Oct 2024 09:03:08 +0100

dpkg (1.22.11ubuntu2) plucky; urgency=medium

  * Default to -O3 on amd64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 19 Oct 2024 10:02:18 +0200

## dpkg 1.22.11ubuntu4

=== debian/changelog ===
dpkg (1.22.11ubuntu4) plucky; urgency=medium

  * Apply Guillem's patch from Debian bug 2093107 to reduce the excessive
    number of dpkg-buildflags calls seen with GNU make 4.4. (LP: #2093107)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 14 Jan 2025 20:30:15 +1300

## dpkg 1.22.11+rpi1

=== debian/changelog ===
dpkg (1.22.11+rpi1) trixie-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )

  [changes introduce in 1.21.17+rpi1 by Peter Michael Green]
  * disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Sun, 18 Aug 2024 06:12:36 +0000

=== debian/rules ===
--- 
+++ 
@@ -65,7 +65,7 @@
 	   $(D)/usr/share/lintian/profiles/dpkg/main.profile
 
 override_dh_auto_test:
-	dh_auto_test -- $(testflags)
+	#dh_auto_test -- $(testflags)
 
 override_dh_installsystemd:
 	dh_installsystemd -a --name=dpkg-db-backup \
@@ -106,9 +106,3 @@
 override_dh_missing:
 	dh_missing -Xdpkg-fsys-usrunmess
 endif
-
-override_dh_builddeb:
-	# Make debootstrap life easier on non-Debian based systems by
-	# compressing dpkg.deb with xz instead of zstd.
-	dh_builddeb -pdpkg -- -Zxz
-	dh_builddeb -Ndpkg

## dpkg 1.22.14~mx23

=== debian/changelog ===
dpkg (1.22.14~mx23) mx; urgency=medium

  * Rebuild for MX-23 Test

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 04 Feb 2025 17:57:36 +0000

dpkg (1.22.14) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Switch from info() to hint() for hint message.
  * Perl modules:
    - Dpkg::BuildDriver::DebianRules: Fix R³ namespace check to only refuse
      unknown dpkg keywords. Closes: #1092653
  * Make fragments:
    - Use flavor to avoid re-caching empty variables. See #1092051.
  * Shell library:
    - Abstract color clearing with a new variable.
    - Lowercase and namespace private variables with _dpkg_.
    - Fix debug output format to print debug in lowercase after progname.
    - Document library interface basics and the version when introduced.
    - Add support for notice(), info() and hint() functions.
  * Code internals:
    - libdpkg: Add support for hint printing.
  * Test suite:
    - Remove redundant <cstdbool> include deprecated in C++17.
  * Localization:
    - Update Brazilian Portuguese dselect translations.
      Thanks to Paulo Henrique de Lima Santana (phls) <phls@debian.org>.
      Closes: #1092593

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Thu, 16 Jan 2025 03:56:38 +0100

dpkg (1.22.13) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Add support for filesystem metadata checks.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Handle all KeyHandle types in
      inline_sign(). See #1091915.
    - Dpkg::OpenPGP::Backend::Sequoia: Check whether we can use the key.
      Closes: #1091915
    - Dpkg::OpenPGP::Backend: Add missing imports. Closes: #1091990
    - Dpkg::BuildDriver::DebianRules: Change default R³ value to «no».
  * Documentation:
    - man: Document the version since the Section and Priority fields have
      defaults.
    - man: Clarify Priority values by mentioning known important and unknown
      ones.
    - man: Clarify Section and Priority values usage tied to distribution
      policies.
    - man: Refer to --sign-keyid instead of --sign-key in DEB_SIGN_KEYID
      description.
  * Code internals:
    - libdpkg: Add test cases for varbuf C++ operators.
    - libdpkg: Do not call varbuf_init() from operator=().
    - dselect: Make sure the search varbuf always has allocated space.
      See #1091898.
    - dselect: Update the search varbuf to account for the used size.
      Closes: #1091898
    - dselect: Fix logic inversion in repeat search keybinding.
    - dselect: Fix formatting for return in keybindings::find().
    - scripts: When printing a field value quote it with double quotes.
    - dpkg-gencontrol: Add missing field name to warning message. See #1091941.
    - dpkg-genchanges: Set Section and Priority defaults even with no fields.
      Closes: #1091941

 -- Guillem Jover <guillem@debian.org>  Fri, 03 Jan 2025 11:47:15 +0100

dpkg (1.22.12) unstable; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Check for pager presence and fallback to less, more and cat.
    Closes: #856216
  * dpkg-shlibdeps: Add symbolic name alternative to --warnings bits.
  * Update URLs.
  * dpkg-deb: Add --no-check option and keep --nocheck as an alias.
  * dpkg: Unify package and version printing format to «package (version)».
  * dpkg-buildtree: Add new command is-rootless.
    Suggested by Niels Thykier <niels@thykier.net>.
  * scripts: Switch messages to be hints.
  * dpkg-buildpackage: Reword hint on unsatisfied dependencies. Closes: #817955
  * dpkg-checkbuilddeps: Improve unmet dependency error messages.
  * dpkg-buildpackage: Switch unmet dependency abort message from warning to
    error.
  * scripts: Change and inject default value for Section and Priority fields.
  * Perl modules:
    - Dpkg::Deps::Multiple: Document that the constructor takes @deps not
      %opts.
    - Dpkg::Changelog::Parse: Use %opts instead of %opt in function POD.
    - Dpkg::Control: Deprecate the backwards compatibility type aliases.
    - Dpkg::OpenPGP::Backend::GnuPG: Ignore
      ValuesAndExpressions::ProhibitMagicNumbers.
    - Dpkg::Vendor: Simplify module loading logic.
    - Dpkg::OpenPGP::Backend::SOP: Add rsop as an alternative SOP
      implementation.
    - Dpkg::OpenPGP::Backend::SOP: Add gosop as an alternative SOP
      implementation.
    - Dpkg::OpenPGP::Backend::Sequoia: Adapt to new CLI 0.40.0 API.
    - Dpkg::OpenPGP::Backend::Sequoia: Add keystore support.
    - Dpkg::Shlibs: Improve code comments.
    - Dpkg::Archive::Ar: Copy only the number of bytes we have read.
    - Dpkg::Vendor: Remove backwards compatibility module and origin name
      mangling.
    - Dpkg::BuildInfo: Add GNUMAKEFLAGS as an allowed environment variable.
      Thanks to Santiago Vila <sanvila@debian.org>. Closes: #1090337
    - Dpkg::BuildDriver::DebianRules: Handle missing root_cmd option.
    - Dpkg::ErrorHandling: Add support for hint printing.
    - Dpkg::OpenPGP::Backend::GnuPG: Handle and warn on concatenated ASCII
      Armor blocks.
    - Revert "Dpkg::OpenPGP::Backend::GnuPG: Fallback to use «gpg dearmor» if
      present".
    - Dpkg::OpenPGP::Backend::GnuPG: Move armor/dearmor implementation to base
      class.
    - Dpkg::OpenPGP::Backend::SOP: Use the parent class armor/dearmor
      implementations.
    - Dpkg::Vendor::Debian: Remove merged-/usr taint logic.
    - Dpkg::Control::FieldsCore: Add new field_get_default_value() function.
  * Make fragments:
    - Document DPKG_BUILD_API in buildapi.mk.
    - Document public API and expected directory to include from.
      Prompted by Helmut Grohne <helmut@subdivi.de>.
    - Capitalize variable descriptions.
    - Clarify format for version variables from pkg-info.mk.
      See #1088244.
    - Add support for new DEB_VERSION_EPOCH and DEB_VERSION_REVISION.
      Closes: #1088244


## dpkg 1.22.14

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
 Uploaders: Guillem Jover <guillem@debian.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
 Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -119,13 +118,12 @@
  patch (>= 2.7),
  make,
  binutils,
- lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,
  fakeroot,
- gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
- gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
+ gnupg | sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq,
+ gpgv | sq | sqop | rsop | gosop | pgpainless-cli | gpgv-sq,
 # Used by dpkg-mergechangelogs.
  libalgorithm-merge-perl,
 Suggests:
@@ -134,9 +132,13 @@
 # Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
  debhelper (<< 10.10.1~),
 # Uses new sq features, w/o requiring a hard dependency on sq.
- sq (<< 0.33.0~),
+ sq (<< 0.40.0~),
 # Uses required SOP features, w/o requiring a hard dependency on sqop.
  sqop (<< 0.27.2~),
+# Uses required SOP features, w/o requiring a hard dependency on rsop.
+ rsop (<< 0.4.0~),
+# Uses required SOP features, w/o requiring a hard dependency on gosop.
+ gosop (<< 1.1.0~),
 # Uses required SOP features, w/o requiring a hard dependency on pgpainless.
  pgpainless-cli (<< 1.3.13~),
  libsop-java-java (<< 4.0.7~),
@@ -155,7 +157,6 @@
 Priority: optional
 Architecture: all
 Multi-Arch: foreign
-Replaces: trisquel-base-data
 Depends:
  ${misc:Depends},
  ${perl:Depends},
@@ -171,8 +172,8 @@
  xz-utils (>= 5.4.0),
 Suggests:
  debian-keyring,
- gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
- gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
+ gnupg | sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq,
+ gpgv | sq | sqop | rsop | gosop | pgpainless-cli | gpgv-sq,
  gcc | c-compiler,
  binutils,
  patch,
@@ -190,9 +191,13 @@
 # versions prior to 1.19.0.
  dgit (<< 3.13~),
 # Uses new sq features, w/o requiring a hard dependency on sq.
- sq (<< 0.33.0~),
+ sq (<< 0.40.0~),
 # Uses required SOP features, w/o requiring a hard dependency on sqop.
  sqop (<< 0.27.2~),
+# Uses required SOP features, w/o requiring a hard dependency on rsop.
+ rsop (<< 0.4.0~),
+# Uses required SOP features, w/o requiring a hard dependency on gosop.
+ gosop (<< 1.1.0~),
 # Uses required SOP features, w/o requiring a hard dependency on pgpainless.
  pgpainless-cli (<< 1.3.13~),
  libsop-java-java (<< 4.0.7~),

## dpkg 1.22.15

=== debian/changelog ===
dpkg (1.22.15) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildDriver::DebianRules: Remove unused Dpkg::BuildAPI import.
    - Dpkg::OpenPGP::Backend::GnuPG: Sign file with fixed up newline.
    - Dpkg::Substvars: Add new set_as_optional() and set_as_required() methods.
  * Documentation:
    - man: Change verb tense for Makefile fragment files descriptions.
    - man: Document that buildapi.mk sets a variable.
    - man: Add reference to buildtools and vendor make fragments to related
      tools.
    - man: Split architecture examples into their own paragraphs.
    - man: Clarify architecture terms and the architecture forms.
    - man: Clarify that build and target are not usual variables to use.
    - doc: Remove duplicate words across newlines.
      Thanks to Michael Biebl <biebl@debian.org>. Closes: #1093548
  * Build system:
    - Add array bounds warning.
    - Add new dialect checks for strict flex array behavior and warnings.
    - Add compiler hardening support.

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

 -- Guillem Jover <guillem@debian.org>  Mon, 03 Feb 2025 12:01:24 +0100

## dpkg 1.22.15+rpi1

=== debian/changelog ===
dpkg (1.22.15+rpi1) trixie-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )

  [changes introduce in 1.21.17+rpi1 by Peter Michael Green]
  * disable testsuite.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 06 Mar 2025 16:00:24 +0000
